/*
 *  basename.c		june 1 89	rjb
 *
 *   * Takes a pathname as an argument - typically argv[0]
 *   - shortens the argument by discarding the trailing .exe or .com
 *   - forces all alphabetic chars to lower case
 *   - discards any leading path component (directory path)
 *         returns char * to the basename of the program
 *         example:     "MYPROG1.COM"   returns "myprog1"
 *			"D:\DIR1\THisPRoG.COM" returns "thisprog"
 */
#include <stdio.h>
#pragma inline
char *basename(char *p)
{
	asm mov     di, p
	asm mov	    si, di		/* provisional result */
	asm mov     ax, '\'
	asm mov	    cx, 'ZA'
	asm mov     dx, ds
	asm mov	    es, dx
	asm cld
	Stringend:
	asm cmp	    [di], ah	/* is it zero (end of string)? */
	asm jnz     Slash	/* no, go test for backslash */
	asm mov     [di-4], ah	/* yes, write a zero at period location */
	asm jmp     byebye
	Slash:
	asm mov     bx, di	/* save for lower case conv */
	asm scasb		/* is it a backslash */
	asm jne     Case	/* no, proceed to next char */
	asm mov     si, di	/* yes, save p++ */
	asm jmp     Stringend	/* do next char */
	Case:			/* going to conv to lower case */
	asm cmp	    byte ptr [bx], ch	/* typically lower already */
	asm ja      Stringend
	asm cmp	    byte ptr [bx], cl
	asm jb      Stringend
	asm add     byte ptr [bx], 'a'-'A'
	asm jmp     Stringend
	byebye:
	asm mov	    ax, si	/* return starting pointer */
}
#ifdef TEST
main(int ac, char *av[])
{
printf("%s\n", basename(av[0]));
}
#endif

