.MODEL	SMALL, PASCAL
; GETLEN.ASM ; part of lline2 ("longest line")
;	Ray Berry Bellevue WA 10/2/89 	CIS 73407,3152
; Counts the number of characters in a line specified by a 
; character pointer.  corrects for tabs and backspaces.
; It returns the length of the line in AX.
	.DATA
EXTRN	_tab_size:BYTE	; specifies size of tab stops
EXTRN	_has_tabs:WORD	; set if tabs encountered here.
	.CODE
GETLEN  proc	USES DI SI, S:PTR BYTE
	xor	dx, dx		; whitespace counter
	xor	di, di		; char cnt
	mov	si, s
	mov	bl, _tab_size
	mov	cx, 0820H	; 8=backspace, 20=space, used for compares
	cld
top: 	lodsb
	cmp	al, cl	; less than 20h (sp) ?
	jb	cntrl
	inc	di	; space or higher, assume printing char
	jmp	top
cntrl:	or	al, al	; end of string?
	jz	done
	sub	al, ch	; backspace? (zero if so)
	jnz	tabchk
	dec	di	; yes, decrement cnt
	jmp	top
tabchk:	dec	al	; tab? (09= BS(08) -1 )
	jz	istab
	jmp	top	; some other cntl char
istab:  inc	_has_tabs
	mov	ax, di
	div	bl	; cnt = ((cnt/tabsize)+1) * tabsize
	inc	al
	mul	bl	; assumes max line length is 255
	mov	di, ax
	jmp	top
done:	mov	ax, di	; return training whitespace cnt (if any)
	ret
GETLEN  endp
	end
